【POJ 1275】 Cashier Employment(差分约束系统的建立和求解)

Cashier Employment
Time Limit: 1000MS   Memory Limit: 10000K
Total Submissions: 7569   Accepted: 2856

Description

A supermarket in Tehran is open 24 hours a day every day and needs a number of cashiers to fit its need. The supermarket manager has hired you to help him, solve his problem. The problem is that the supermarket needs different
number of cashiers at different times of each day (for example, a few cashiers after midnight, and many in the afternoon) to provide good service to its customers, and he wants to hire the least number of cashiers for this job.



The manager has provided you with the least number of cashiers needed for every one-hour slot of the day. This data is given as R(0), R(1), ..., R(23): R(0) represents the least number of cashiers needed from midnight to 1:00 A.M., R(1) shows this number for
duration of 1:00 A.M. to 2:00 A.M., and so on. Note that these numbers are the same every day. There are N qualified applicants for this job. Each applicant i works non-stop once each 24 hours in a shift of exactly 8 hours starting from a specified hour, say
ti (0 <= ti <= 23), exactly from the start of the hour mentioned. That is, if the ith applicant is hired, he/she will work starting from ti o'clock sharp for 8 hours. Cashiers do not replace one another and work exactly as scheduled, and there are enough cash
registers and counters for those who are hired.



You are to write a program to read the R(i) 's for i=0..23 and ti 's for i=1..N that are all, non-negative integer numbers and compute the least number of cashiers needed to be employed to meet the mentioned constraints. Note that there can be more cashiers
than the least number needed for a specific slot.

Input

The first line of input is the number of test cases for this problem (at most 20). Each test case starts with 24 integer numbers representing the R(0), R(1), ..., R(23) in one line (R(i) can be at most 1000). Then there is N, number
of applicants in another line (0 <= N <= 1000), after which come N lines each containing one ti (0 <= ti <= 23). There are no blank lines between test cases.

Output

For each test case, the output should be written in one line, which is the least number of cashiers needed.

If there is no solution for the test case, you should write No Solution for that case.

Sample Input

1
1 0 1 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1
5
0
23
22
1
10

Sample Output

1

Source

做到如今为止 做的最麻烦的一个差分约束……

麻烦不是麻烦在求解上。而是建图……而且绝大多数差分约束的难点。都是建图。。毕竟求解就是个裸最短路

这题题意是 一个商店要招聘员工 商店有一个客流表 表示0~23点每点须要的最少员工数

之后一个整数n 表示有n个应聘员工

后面n行 每行一个0~23的整数 表示第i个员工工作的起始时间 每一个员工工作8小时

题目分析完成 条件不多 所以这就是这题的难点……要挖掘非常多隐含条件

设t[i]为商店第i小时须要的员工数 r[i]表示第i小时来应聘的员工数 数组S[i]表示0~i小时总共应聘的员工数

第一个条件 0 <= S[i]-S[i-1] <= r[i]

第二个条件 S[i]-S[i-8] >= t[i] (i-1时i-8招聘的员工刚好下班 因此S[i]-S[i-8]即为第i小时招聘的所有员工)

第三个条件 S[24]-S[0] <= sum(因为要找最少的总招聘人数,所以这里出现了一个未知量,而这个问题就转化成了求最小sum)

把三个问题化成同号 再细化一下 就变成了

S[i-1]-S[i] <= 0

S[i]-S[i-1] <= r[i]

S[i-8]-S[i] <= -t[i](0 < i <= 8)

S[i+16]-S[i] <= sum-t[i](8 < i <= 24)

S[24]-S[0] <= sum

找到不等关系就好办一点了 对sum二分 每次更新与sum有关的边权 然后跑最短路 推断一下能不能跑出来(有无负环)

代码例如以下:

#include <iostream>
#include <cmath>
#include <vector>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <queue>
#include <list>
#include <algorithm>
#include <map>
#include <set>
#define LL long long
#define Pr pair<int,int>
#define fread() freopen("in.in","r",stdin)
#define fwrite() freopen("out.out","w",stdout) using namespace std;
const int INF = 0x3f3f3f3f;
const int msz = 10000;
const double eps = 1e-8; struct Edge
{
int u,v,w;
}; Edge eg[233333];
int w[25],r[25];
int dis[25];
int tp; bool bellman()
{
memset(dis,INF,sizeof(dis));
dis[0] = 0; for(int i = 0; i <= 24; ++i)
for(int j = 0; j < tp; ++j)
if(dis[eg[j].v] > dis[eg[j].u]+eg[j].w)
dis[eg[j].v] = dis[eg[j].u]+eg[j].w; //判负环
for(int j = 0; j < tp; ++j)
if(dis[eg[j].v] > dis[eg[j].u]+eg[j].w)
return false; return true;
} void Add(int u,int v,int w)
{
eg[tp].u = u;
eg[tp].v = v;
eg[tp++].w = w;
} //重建与sum有关的边
void buildgraph(int sum)
{
tp = 64;
for(int i = 1; i < 9; ++i)
Add(i,i+16,sum-w[i]);
Add(24,0,-sum);
} int main()
{
int t,x,n,low,high; scanf("%d",&t);
while(t--)
{
tp = 0; high = 0;
for(int i = 1; i <= 24; ++i)
scanf("%d",&w[i]); memset(r,0,sizeof(r));
scanf("%d",&n);
high = n; while(n--)
{
scanf("%d",&x);
r[x+1]++;
} //边权不变的边(与sum无关的边)
for(int i = 1; i <= 24; ++i)
{
Add(i-1,i,r[i]);
Add(i,i-1,0);
if(i >= 9) Add(i,i-8,-w[i]);
} low = 0;
int ans = INF;
while(low <= high)
{
int mid = (low+high)>>1; buildgraph(mid);
if(bellman())
{
ans = mid;
high = mid-1;
}else low = mid+1;
} if(ans == INF) puts("No Solution");
else printf("%d\n",ans);
} return 0;
}

id=1275">

【POJ 1275】 Cashier Employment(差分约束系统的建立和求解)的更多相关文章

  1. poj 1275 Cashier Employment - 差分约束 - 二分答案

    A supermarket in Tehran is open 24 hours a day every day and needs a number of cashiers to fit its n ...

  2. [HDU 1529]Cashier Employment(差分约束系统)

    [HDU 1529]Cashier Employment(差分约束系统) 题面 有一个超市,在24小时对员工都有一定需求量,表示为\(r_i\),意思为在i这个时间至少要有i个员工,现在有n个员工来应 ...

  3. 图论(差分约束系统):POJ 1275 Cashier Employment

    Cashier Employment Time Limit: 1000MS   Memory Limit: 10000K Total Submissions: 7651   Accepted: 288 ...

  4. POJ 1275 Cashier Employment 挺难的差分约束题

    http://poj.org/problem?id=1275 题目大意: 一商店二十四小时营业,但每个时间段需求的雇员数不同(已知,设为R[i]),现有n个人申请这份工作,其可以从固定时间t连续工作八 ...

  5. POJ1275 Cashier Employment[差分约束系统 || 单纯形法]

    Cashier Employment Time Limit: 1000MS   Memory Limit: 10000K Total Submissions: 7997   Accepted: 305 ...

  6. POJ 1275 Cashier Employment(差分约束)

    http://poj.org/problem?id=1275 题意 : 一家24小时营业的超市,要雇出纳员,需要求出超市每天不同时段需要的出纳员数,午夜只需一小批,下午需要多些,希望雇最少的人,给出每 ...

  7. poj 1275 Cashier Employment

    http://poj.org/problem?id=1275 #include <cstdio> #include <cstring> #include <algorit ...

  8. POJ 1275-Cashier Employment(差分约束系统)

    题目地址:id=1275">POJ 1275 题意: 给出一个超市24小时各须要R[i]个雇员工作,有N个雇员能够雇佣.他们開始工作时间分别为A[i],求须要的最少的雇员人数. 思路: ...

  9. 【POJ1275】Cashier Employment 差分约束

    [POJ1275]Cashier Employment 题意: 超市经历已经提供一天里每一小时需要出纳员的最少数量————R(0),R(1),...,R(23).R(0)表示从午夜到凌晨1:00所需要 ...

随机推荐

  1. CS2QS

    inline QString MotorCS2QS(CString cs) { return QString::fromWCharArray((LPCTSTR)cs, cs.GetLength()); ...

  2. Java基础(十二)--clone()方法

    Clone在Java中就是用来复制对象,通过分配一个和源对象相同大小的内存空间,然后创建一个新的对象,那么他和=的区别在哪? 通过=实现对象拷贝: @Data @NoArgsConstructor @ ...

  3. vue-cli 中使用less

    (1)安装Less模块: npm install less (2)安装less和less-loader,命令如下 npm install less less-loader --sava-dev (3) ...

  4. vue列表排序实现中的this问题

    最近在看vue框架的知识,然后其中有个例子中的this的写法让我很疑惑 <!DOCTYPE html> <html> <head> <meta charset ...

  5. PHP 反射API

    出处:http://blog.csdn.net/hguisu/article/details/7357421 PHP5添加了一项新的功能:Reflection.这个功能使得phper可以reverse ...

  6. leetcode-169求众数

    求众数 思路: 记录每个元素出现的次数,然后查找到众数 代码: class Solution: def majorityElement(self, nums: List[int]) -> int ...

  7. 基础知识:if条件、while循环、for循环 相关练习

    1.实现用户输入用户名和密码,当用户名为 seven 且 密码为 123 时,显示登陆成功,否则登陆失败! while True: name = input('请输入用户名:') psw = inpu ...

  8. 集训第五周动态规划 J题 括号匹配

    Description We give the following inductive definition of a “regular brackets” sequence: the empty s ...

  9. JavaScript学习---简易图片轮播

    效果如下: 图片定时轮播 点击左右控制显示下一张或上一张图片 index.html文件 <html> <head> <title> js编写实现幻灯片效果 < ...

  10. 热部署jredel介绍

    在进行java web程序开发过程中,经常遇到这种问题,修改一个java文件(*.java),需要重启web服务器(如tomcat,weblogic等),部署项目.而起/停服务器浪费了大量的时间.在小 ...